﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using SimpleSalesTrackingAPIWrapper;
using SimpleSalesTrackingAPIWrapper.SimpleSalesTrackingAPI;

namespace SimpleSalesTrackingAPISample
{
    public partial class Form1 : Form
    {
        List<Note> notes;
        List<Task> tasks;

        public Form1()
        {
            InitializeComponent();

            // Get list of Sales
            List<SaleSimple> sales = new List<SaleSimple>(Sales.GetSalesSimpleNotClosed(
                ConfigurationManager.AppSettings["Username"], 
                ConfigurationManager.AppSettings["Password"]));

            listBox1.DataSource = sales;
            listBox1.DisplayMember = "Name";
            listBox1.ValueMember = "SaleId";

            // Get list of Notes belonging to the selected sale.
            notes = new List<Note>(Notes.GetNotesByOwner(
                ConfigurationManager.AppSettings["Username"],
                ConfigurationManager.AppSettings["Password"]));

            listBox2.DisplayMember = "Name";
            listBox2.ValueMember = "NoteId";

            // Get list of Tasks belonging to the selected sale.
            tasks = new List<Task>(Tasks.GetTasksByOwner(
                ConfigurationManager.AppSettings["Username"],
                ConfigurationManager.AppSettings["Password"]));

            listBox3.DisplayMember = "Name";
            listBox3.ValueMember = "TaskId";
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (notes != null)
            {
                List<Note> filteredNotes = new List<Note>();

                foreach (Note note in notes)
                {
                    if (note.SaleId == Int32.Parse(listBox1.SelectedValue.ToString()))
                        filteredNotes.Add(note);
                }

                listBox2.DataSource = filteredNotes;
            }

            if (tasks != null)
            {
                List<Task> filteredTasks = new List<Task>();

                foreach (Task task in tasks)
                {
                    if (task.SaleId == Int32.Parse(listBox1.SelectedValue.ToString()))
                        filteredTasks.Add(task);
                }

                listBox3.DataSource = filteredTasks;
            }
        }

        private void listBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listBox2 != null)
            {
                webBrowser1.Navigate("about:blank");

                if (webBrowser1.Document != null)
                    webBrowser1.Document.Write(string.Empty);
                
                webBrowser1.DocumentText = Notes.GetNoteById(
                    ConfigurationManager.AppSettings["Username"],
                    ConfigurationManager.AppSettings["Password"],
                    Int32.Parse(listBox2.SelectedValue.ToString())).Description;
            }
        }

        private void listBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listBox3 != null)
            {
                webBrowser2.Navigate("about:blank");

                if (webBrowser2.Document != null)
                    webBrowser2.Document.Write(string.Empty);

                webBrowser2.DocumentText = Tasks.GetTaskById(
                    ConfigurationManager.AppSettings["Username"],
                    ConfigurationManager.AppSettings["Password"],
                    Int32.Parse(listBox3.SelectedValue.ToString())).Description;
            }
        }


    }
}
